################################################################################

{{- $cronFirst := (keys .Values.cron.jobs) | first }}
{{- range $key, $job := .Values.cron.jobs }}

{{- if ne $key $cronFirst }}
---
{{- end }}

apiVersion: batch/v1
kind: CronJob
metadata:
  name: "{{ $.Release.Name }}-cron-{{ $key }}"
  labels:
    k8s.bitservices.io/cron: "{{ $key }}"
{{- include "standalone.cron.labels" $ | indent 4 }}
spec:
  schedule: "{{ $job.schedule | default $.Values.cron.defaults.schedule }}"
  jobTemplate: 
    spec:
      template:
        metadata:
          labels:
            k8s.bitservices.io/cron: "{{ $key }}"
{{- include "standalone.cron.labels" $ | indent 12 }}
        spec:
          containers:
            - name: "{{ $.Values.global.image.container }}"
              image: "{{ tpl $.Values.global.image.name $ }}:{{ tpl $.Values.global.image.release $ }}"
{{- if $.Values.global.image.forcePull }}
              imagePullPolicy: Always
{{- end }}
{{- if ($job.args) }}
              args:
{{- range $job.args }}
                - "{{ . }}"
{{- end }}
{{- end }}
{{- if ($job.command) }}
              command:
{{- range $job.command }}
                - "{{ . }}"
{{- end }}
{{- end }}
{{- if or $.Values.global.envSecrets $.Values.cron.envSecrets
          $.Values.global.envValues $.Values.cron.envValues
          ($job.envSecrets) ($job.envValues) }}
              env:
{{- if or $.Values.global.envSecrets
          $.Values.cron.envSecrets
          ($job.envSecrets) }}
{{- range $name, $value := merge ($job.envSecrets) $.Values.cron.envSecrets $.Values.global.envSecrets }}
                - name: "{{ $name }}"
                  valueFrom:
                    secretKeyRef:
                      name: "{{ $value.secretName }}"
                      key: "{{ $value.secretKey }}"
{{- end }}
{{- end }}
{{- if or $.Values.global.envValues
          $.Values.cron.envValues
          ($job.envValues) }}
{{- range $name, $value := merge ($job.envValues) $.Values.cron.envValues $.Values.global.envValues }}
                - name: "{{ $name }}"
                  value: "{{ tpl (toString $value) $ }}"
{{- end }}
{{- end }}
{{- end }}
              resources:
{{- if ($job.resources) }}
{{ toYaml (merge (deepCopy $job.resources)
                 (deepCopy $.Values.cron.defaults.resources)) | indent 16 }}
{{- else }}
{{ toYaml $.Values.cron.defaults.resources | indent 16 }}
{{- end }}
{{- if (or (eq $.Values.global.filesystem.type "efs")
           (eq $.Values.global.filesystem.type "local")) }}
              volumeMounts:
                - name: shared-data
                  mountPath: "{{ $.Values.global.filesystem.mountPath }}"
{{- end }}
          securityContext:
            runAsUser: 33
            runAsNonRoot: true
          serviceAccountName: "{{ $.Release.Name }}-cron-{{ $key }}"
{{- if (or (eq $.Values.global.filesystem.type "efs")
           (eq $.Values.global.filesystem.type "local")) }}
          volumes:
            - name: shared-data
{{- if eq $.Values.global.filesystem.type "efs" }}
              persistentVolumeClaim:
                claimName: "{{ .Release.Name }}"
{{- else if eq $.Values.global.filesystem.type "local" }}
              hostPath:
                path: /shared-data
{{- end }}
{{- end }}

{{- end }}

################################################################################
